<?php
declare(strict_types=1);

namespace App\Entity\Message;

use App\Attribute\OrganizationDefaultValue;
use App\Entity\Organization\Organization;
use App\Enum\Message\MessageStatusEnum;
use Doctrine\ORM\Mapping as ORM;
use Ramsey\Uuid\UuidInterface;
use Ramsey\Uuid\Doctrine\UuidGenerator;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Types\UuidType;

/**
 * Classe ... qui ...
 */
#[ORM\MappedSuperclass]
#[OrganizationDefaultValue(fieldName: "organization")]
abstract class AbstractMessage
{
    #[ORM\Id]
    #[ORM\Column]
    #[ORM\GeneratedValue]
    protected ?int $id = null;

    /**
     * @var UuidInterface|null
     */
    #[ORM\Column(type: "uuid", unique: true)]
    #[ORM\GeneratedValue(strategy: "CUSTOM")]
    #[ORM\CustomIdGenerator(class: UuidGenerator::class)]
    protected ?UuidInterface $uuid = null;

    #[ORM\ManyToOne]
    #[ORM\JoinColumn(nullable: true)]
    protected Organization $organization;

    #[ORM\Column(type: 'string', options: ['default' => 'DRAFT'])]
    #[Assert\Choice(callback: [MessageStatusEnum::class, 'toArray'], message: 'invalid-departure-cause')]
    protected string $status;

    // @todo remplacer par le nom sendingDate
    #[ORM\Column(type: 'datetime', nullable: true)]
    protected ?\DateTimeInterface $dateSent = null;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    protected string $about;

    #[ORM\Column(type: 'text', nullable: true)]
    protected string $text;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getUuid(): ?UuidInterface
    {
        return $this->uuid;
    }

    public function setOrganization(Organization $organization): self
    {
        $this->organization = $organization;
        return $this;
    }

    public function getOrganization(): Organization
    {
        return $this->organization;
    }

    public function setAbout(string $about): self
    {
        $this->about = $about;
        return $this;
    }

    public function getAbout(): string
    {
        return $this->about;
    }

    public function setText(string $text): self
    {
        $this->text = $text;
        return $this;
    }

    public function getText(): string
    {
        return html_entity_decode($this->text);
    }

    public function setStatus(string $status): self
    {
        $this->status = $status;

        return $this;
    }

    public function getStatus(): string
    {
        return $this->status;
    }


    public function setDateSent(\DateTimeInterface $dateSent): self
    {
        $this->dateSent = $dateSent;

        return $this;
    }

    public function getDateSent(): ?\DateTimeInterface
    {
        return $this->dateSent;
    }
}
